import type { MergeStrategy } from '../../../config/types';
import type { BranchStatus } from '../../../types';
import type { HttpOptions } from '../../../util/http/types';
import type { Pr } from '../types';
import type { BitbucketBranchState, MergeRequestBody, PrResponse, RepoInfo, RepoInfoBody } from './types';
export declare function repoInfoTransformer(repoInfoBody: RepoInfoBody): RepoInfo;
export declare function mergeBodyTransformer(mergeStrategy: MergeStrategy | undefined): MergeRequestBody;
export declare const prStates: {
    open: string[];
    notOpen: string[];
    merged: string[];
    closed: string[];
    all: string[];
};
export declare const buildStates: Record<BranchStatus, BitbucketBranchState>;
export declare function accumulateValues<T = any>(reqUrl: string, method?: string, options?: HttpOptions, pagelen?: number): Promise<T[]>;
export declare function prInfo(pr: PrResponse): Pr;
